Package com.google.gwt.view.client

## Interface HasRows

- All Superinterfaces:
    `HasHandlers`
  All Known Subinterfaces:
    `HasData<T>`
  All Known Implementing Classes:
    `AbstractCellTable`, `AbstractHasData`, `CellBrowser.BrowserCellList`, `CellList`, `CellTable`, `CellTreeNodeView.NodeCellList`, `DataGrid`, `HasDataPresenter`

      public interface HasRows
      extends HasHandlers

  Describes an object that displays a range of rows.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HandlerRegistration` | `addRangeChangeHandler​(RangeChangeEvent.Handler handler)` | Add a `RangeChangeEvent.Handler`.
    `HandlerRegistration` | `addRowCountChangeHandler​(RowCountChangeEvent.Handler handler)` | Add a `RowCountChangeEvent.Handler`.
    `int` | `getRowCount()` | Get the total count of all rows.
    `Range` | `getVisibleRange()` | Get the range of visible rows.
    `boolean` | `isRowCountExact()` | Check if the total row count is exact, or an estimate.
    `void` | `setRowCount​(int count)` | Set the exact total count of all rows.
    `void` | `setRowCount​(int count, boolean isExact)` | Set the total count of all rows, specifying whether the count is exact or an estimate.
    `void` | `setVisibleRange​(int start, int length)` | Set the visible range or rows.
    `void` | `setVisibleRange​(Range range)` | Set the visible range or rows.

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Method Detail

    - #### addRangeChangeHandler

          HandlerRegistration addRangeChangeHandler​(RangeChangeEvent.Handler handler)

      Add a `RangeChangeEvent.Handler`.
      Parameters:
        `handler` - the handler
      Returns:
        a `HandlerRegistration` to remove the handler

    - #### addRowCountChangeHandler

          HandlerRegistration addRowCountChangeHandler​(RowCountChangeEvent.Handler handler)

      Add a `RowCountChangeEvent.Handler`.
      Parameters:
        `handler` - the handler
      Returns:
        a `HandlerRegistration` to remove the handler

    - #### getRowCount

          int getRowCount()

      Get the total count of all rows.
      Returns:
        the total row count
      See Also:
        `setRowCount(int)`

    - #### getVisibleRange

          Range getVisibleRange()

      Get the range of visible rows.
      Returns:
        the visible range
      See Also:
        `setVisibleRange(Range)`, `setVisibleRange(int, int)`

    - #### isRowCountExact

          boolean isRowCountExact()

      Check if the total row count is exact, or an estimate.
      Returns:
        true if exact, false if an estimate

    - #### setRowCount

          void setRowCount​(int count)

      Set the exact total count of all rows. This method defers to `setRowCount(int, boolean)`.
      Parameters:
        `count` - the exact total count
      See Also:
        `getRowCount()`

    - #### setRowCount

          void setRowCount​(int count,
                           boolean isExact)

      Set the total count of all rows, specifying whether the count is exact or an estimate.
      Parameters:
        `count` - the total count
        `isExact` - true if the count is exact, false if an estimate
      See Also:
        `getRowCount()`

    - #### setVisibleRange

          void setVisibleRange​(int start,
                               int length)

      Set the visible range or rows. This method defers to `setVisibleRange(Range)`.
      Parameters:
        `start` - the start index
        `length` - the length
      See Also:
        `getVisibleRange()`

    - #### setVisibleRange

          void setVisibleRange​(Range range)

      Set the visible range or rows.
      Parameters:
        `range` - the visible range
      See Also:
        `getVisibleRange()`